// Code generated by ent, DO NOT EDIT.

package hook

import (
	"context"
	"doc-service/domain/entity/serversitemicros"
	"fmt"
)

// The DocServerAppFunc type is an adapter to allow the use of ordinary
// function as DocServerApp mutator.
type DocServerAppFunc func(context.Context, *serversitemicros.DocServerAppMutation) (serversitemicros.Value, error)

// Mutate calls f(ctx, m).
func (f DocServerAppFunc) Mutate(ctx context.Context, m serversitemicros.Mutation) (serversitemicros.Value, error) {
	if mv, ok := m.(*serversitemicros.DocServerAppMutation); ok {
		return f(ctx, mv)
	}
	return nil, fmt.Errorf("unexpected mutation type %T. expect *serversitemicros.DocServerAppMutation", m)
}

// The DocServerCallbackFunc type is an adapter to allow the use of ordinary
// function as DocServerCallback mutator.
type DocServerCallbackFunc func(context.Context, *serversitemicros.DocServerCallbackMutation) (serversitemicros.Value, error)

// Mutate calls f(ctx, m).
func (f DocServerCallbackFunc) Mutate(ctx context.Context, m serversitemicros.Mutation) (serversitemicros.Value, error) {
	if mv, ok := m.(*serversitemicros.DocServerCallbackMutation); ok {
		return f(ctx, mv)
	}
	return nil, fmt.Errorf("unexpected mutation type %T. expect *serversitemicros.DocServerCallbackMutation", m)
}

// The DocServerGetProjectFunc type is an adapter to allow the use of ordinary
// function as DocServerGetProject mutator.
type DocServerGetProjectFunc func(context.Context, *serversitemicros.DocServerGetProjectMutation) (serversitemicros.Value, error)

// Mutate calls f(ctx, m).
func (f DocServerGetProjectFunc) Mutate(ctx context.Context, m serversitemicros.Mutation) (serversitemicros.Value, error) {
	if mv, ok := m.(*serversitemicros.DocServerGetProjectMutation); ok {
		return f(ctx, mv)
	}
	return nil, fmt.Errorf("unexpected mutation type %T. expect *serversitemicros.DocServerGetProjectMutation", m)
}

// The DocServerProjectFunc type is an adapter to allow the use of ordinary
// function as DocServerProject mutator.
type DocServerProjectFunc func(context.Context, *serversitemicros.DocServerProjectMutation) (serversitemicros.Value, error)

// Mutate calls f(ctx, m).
func (f DocServerProjectFunc) Mutate(ctx context.Context, m serversitemicros.Mutation) (serversitemicros.Value, error) {
	if mv, ok := m.(*serversitemicros.DocServerProjectMutation); ok {
		return f(ctx, mv)
	}
	return nil, fmt.Errorf("unexpected mutation type %T. expect *serversitemicros.DocServerProjectMutation", m)
}

// Condition is a hook condition function.
type Condition func(context.Context, serversitemicros.Mutation) bool

// And groups conditions with the AND operator.
func And(first, second Condition, rest ...Condition) Condition {
	return func(ctx context.Context, m serversitemicros.Mutation) bool {
		if !first(ctx, m) || !second(ctx, m) {
			return false
		}
		for _, cond := range rest {
			if !cond(ctx, m) {
				return false
			}
		}
		return true
	}
}

// Or groups conditions with the OR operator.
func Or(first, second Condition, rest ...Condition) Condition {
	return func(ctx context.Context, m serversitemicros.Mutation) bool {
		if first(ctx, m) || second(ctx, m) {
			return true
		}
		for _, cond := range rest {
			if cond(ctx, m) {
				return true
			}
		}
		return false
	}
}

// Not negates a given condition.
func Not(cond Condition) Condition {
	return func(ctx context.Context, m serversitemicros.Mutation) bool {
		return !cond(ctx, m)
	}
}

// HasOp is a condition testing mutation operation.
func HasOp(op serversitemicros.Op) Condition {
	return func(_ context.Context, m serversitemicros.Mutation) bool {
		return m.Op().Is(op)
	}
}

// HasAddedFields is a condition validating `.AddedField` on fields.
func HasAddedFields(field string, fields ...string) Condition {
	return func(_ context.Context, m serversitemicros.Mutation) bool {
		if _, exists := m.AddedField(field); !exists {
			return false
		}
		for _, field := range fields {
			if _, exists := m.AddedField(field); !exists {
				return false
			}
		}
		return true
	}
}

// HasClearedFields is a condition validating `.FieldCleared` on fields.
func HasClearedFields(field string, fields ...string) Condition {
	return func(_ context.Context, m serversitemicros.Mutation) bool {
		if exists := m.FieldCleared(field); !exists {
			return false
		}
		for _, field := range fields {
			if exists := m.FieldCleared(field); !exists {
				return false
			}
		}
		return true
	}
}

// HasFields is a condition validating `.Field` on fields.
func HasFields(field string, fields ...string) Condition {
	return func(_ context.Context, m serversitemicros.Mutation) bool {
		if _, exists := m.Field(field); !exists {
			return false
		}
		for _, field := range fields {
			if _, exists := m.Field(field); !exists {
				return false
			}
		}
		return true
	}
}

// If executes the given hook under condition.
//
//	hook.If(ComputeAverage, And(HasFields(...), HasAddedFields(...)))
func If(hk serversitemicros.Hook, cond Condition) serversitemicros.Hook {
	return func(next serversitemicros.Mutator) serversitemicros.Mutator {
		return serversitemicros.MutateFunc(func(ctx context.Context, m serversitemicros.Mutation) (serversitemicros.Value, error) {
			if cond(ctx, m) {
				return hk(next).Mutate(ctx, m)
			}
			return next.Mutate(ctx, m)
		})
	}
}

// On executes the given hook only for the given operation.
//
//	hook.On(Log, serversitemicros.Delete|serversitemicros.Create)
func On(hk serversitemicros.Hook, op serversitemicros.Op) serversitemicros.Hook {
	return If(hk, HasOp(op))
}

// Unless skips the given hook only for the given operation.
//
//	hook.Unless(Log, serversitemicros.Update|serversitemicros.UpdateOne)
func Unless(hk serversitemicros.Hook, op serversitemicros.Op) serversitemicros.Hook {
	return If(hk, Not(HasOp(op)))
}

// FixedError is a hook returning a fixed error.
func FixedError(err error) serversitemicros.Hook {
	return func(serversitemicros.Mutator) serversitemicros.Mutator {
		return serversitemicros.MutateFunc(func(context.Context, serversitemicros.Mutation) (serversitemicros.Value, error) {
			return nil, err
		})
	}
}

// Reject returns a hook that rejects all operations that match op.
//
//	func (T) Hooks() []serversitemicros.Hook {
//		return []serversitemicros.Hook{
//			Reject(serversitemicros.Delete|serversitemicros.Update),
//		}
//	}
func Reject(op serversitemicros.Op) serversitemicros.Hook {
	hk := FixedError(fmt.Errorf("%s operation is not allowed", op))
	return On(hk, op)
}

// Chain acts as a list of hooks and is effectively immutable.
// Once created, it will always hold the same set of hooks in the same order.
type Chain struct {
	hooks []serversitemicros.Hook
}

// NewChain creates a new chain of hooks.
func NewChain(hooks ...serversitemicros.Hook) Chain {
	return Chain{append([]serversitemicros.Hook(nil), hooks...)}
}

// Hook chains the list of hooks and returns the final hook.
func (c Chain) Hook() serversitemicros.Hook {
	return func(mutator serversitemicros.Mutator) serversitemicros.Mutator {
		for i := len(c.hooks) - 1; i >= 0; i-- {
			mutator = c.hooks[i](mutator)
		}
		return mutator
	}
}

// Append extends a chain, adding the specified hook
// as the last ones in the mutation flow.
func (c Chain) Append(hooks ...serversitemicros.Hook) Chain {
	newHooks := make([]serversitemicros.Hook, 0, len(c.hooks)+len(hooks))
	newHooks = append(newHooks, c.hooks...)
	newHooks = append(newHooks, hooks...)
	return Chain{newHooks}
}

// Extend extends a chain, adding the specified chain
// as the last ones in the mutation flow.
func (c Chain) Extend(chain Chain) Chain {
	return c.Append(chain.hooks...)
}
