// Code generated by ent, DO NOT EDIT.

package migrate

import (
	"entgo.io/ent/dialect/entsql"
	"entgo.io/ent/dialect/sql/schema"
	"entgo.io/ent/schema/field"
)

var (
	// DocServerAppColumns holds the columns for the "doc_server_app" table.
	DocServerAppColumns = []*schema.Column{
		{Name: "id", Type: field.TypeInt32, Increment: true, SchemaType: map[string]string{"mysql": "int"}},
		{Name: "application", Type: field.TypeString, SchemaType: map[string]string{"mysql": "varchar(128)"}},
		{Name: "name", Type: field.TypeString, Default: "", SchemaType: map[string]string{"mysql": "varchar(32)"}},
		{Name: "created_at", Type: field.TypeTime, Nullable: true, SchemaType: map[string]string{"mysql": "datetime"}},
	}
	// DocServerAppTable holds the schema information for the "doc_server_app" table.
	DocServerAppTable = &schema.Table{
		Name:       "doc_server_app",
		Columns:    DocServerAppColumns,
		PrimaryKey: []*schema.Column{DocServerAppColumns[0]},
	}
	// DocServerCallbackColumns holds the columns for the "doc_server_callback" table.
	DocServerCallbackColumns = []*schema.Column{
		{Name: "id", Type: field.TypeInt32, Increment: true, SchemaType: map[string]string{"mysql": "int"}},
		{Name: "server_project_id", Type: field.TypeInt32, Default: 0, SchemaType: map[string]string{"mysql": "int"}},
		{Name: "callback_url", Type: field.TypeString, Default: "", SchemaType: map[string]string{"mysql": "varchar(255)"}},
		{Name: "callback_data", Type: field.TypeString, Default: "", SchemaType: map[string]string{"mysql": "varchar(255)"}},
		{Name: "callback_type", Type: field.TypeInt8, Default: 0, SchemaType: map[string]string{"mysql": "tinyint"}},
		{Name: "status", Type: field.TypeInt8, SchemaType: map[string]string{"mysql": "tinyint"}},
		{Name: "curr_num", Type: field.TypeInt32, Default: 0, SchemaType: map[string]string{"mysql": "int"}},
		{Name: "created_at", Type: field.TypeTime, Nullable: true, SchemaType: map[string]string{"mysql": "datetime"}},
		{Name: "updated_at", Type: field.TypeTime, Nullable: true, SchemaType: map[string]string{"mysql": "datetime"}},
		{Name: "deleted_at", Type: field.TypeTime, Nullable: true, SchemaType: map[string]string{"mysql": "datetime"}},
	}
	// DocServerCallbackTable holds the schema information for the "doc_server_callback" table.
	DocServerCallbackTable = &schema.Table{
		Name:       "doc_server_callback",
		Columns:    DocServerCallbackColumns,
		PrimaryKey: []*schema.Column{DocServerCallbackColumns[0]},
	}
	// DocServerGetProjectColumns holds the columns for the "doc_server_get_project" table.
	DocServerGetProjectColumns = []*schema.Column{
		{Name: "id", Type: field.TypeInt32, Increment: true, SchemaType: map[string]string{"mysql": "int"}},
		{Name: "server_project_id", Type: field.TypeInt32, Default: 0, SchemaType: map[string]string{"mysql": "int"}},
		{Name: "curr_num", Type: field.TypeInt32, Default: 0, SchemaType: map[string]string{"mysql": "int"}},
		{Name: "status", Type: field.TypeInt8, SchemaType: map[string]string{"mysql": "tinyint"}},
		{Name: "ali_result", Type: field.TypeString, Nullable: true, Size: 65535, SchemaType: map[string]string{"mysql": "text"}},
		{Name: "created_at", Type: field.TypeTime, Nullable: true, SchemaType: map[string]string{"mysql": "datetime"}},
		{Name: "updated_at", Type: field.TypeTime, Nullable: true, SchemaType: map[string]string{"mysql": "datetime"}},
	}
	// DocServerGetProjectTable holds the schema information for the "doc_server_get_project" table.
	DocServerGetProjectTable = &schema.Table{
		Name:       "doc_server_get_project",
		Columns:    DocServerGetProjectColumns,
		PrimaryKey: []*schema.Column{DocServerGetProjectColumns[0]},
	}
	// DocServerProjectColumns holds the columns for the "doc_server_project" table.
	DocServerProjectColumns = []*schema.Column{
		{Name: "id", Type: field.TypeInt32, Increment: true, SchemaType: map[string]string{"mysql": "int"}},
		{Name: "project_name", Type: field.TypeString, Default: "", SchemaType: map[string]string{"mysql": "varchar(32)"}},
		{Name: "source_type", Type: field.TypeString, Default: "", SchemaType: map[string]string{"mysql": "varchar(16)"}},
		{Name: "target_type", Type: field.TypeString, Default: "", SchemaType: map[string]string{"mysql": "varchar(16)"}},
		{Name: "source_url", Type: field.TypeString, Nullable: true, Size: 65535, SchemaType: map[string]string{"mysql": "text"}},
		{Name: "target_url", Type: field.TypeString, Nullable: true, Size: 65535, SchemaType: map[string]string{"mysql": "text"}},
		{Name: "task_id", Type: field.TypeString, Default: "", SchemaType: map[string]string{"mysql": "varchar(128)"}},
		{Name: "app_id", Type: field.TypeInt32, Default: 0, SchemaType: map[string]string{"mysql": "int"}},
		{Name: "is_private", Type: field.TypeInt8, Default: 0, SchemaType: map[string]string{"mysql": "tinyint"}},
		{Name: "status", Type: field.TypeInt32, Default: 0, SchemaType: map[string]string{"mysql": "int"}},
		{Name: "callback_res", Type: field.TypeString, Size: 65535, SchemaType: map[string]string{"mysql": "text"}},
		{Name: "created_at", Type: field.TypeTime, Nullable: true, SchemaType: map[string]string{"mysql": "datetime"}},
	}
	// DocServerProjectTable holds the schema information for the "doc_server_project" table.
	DocServerProjectTable = &schema.Table{
		Name:       "doc_server_project",
		Columns:    DocServerProjectColumns,
		PrimaryKey: []*schema.Column{DocServerProjectColumns[0]},
	}
	// Tables holds all the tables in the schema.
	Tables = []*schema.Table{
		DocServerAppTable,
		DocServerCallbackTable,
		DocServerGetProjectTable,
		DocServerProjectTable,
	}
)

func init() {
	DocServerAppTable.Annotation = &entsql.Annotation{
		Table: "doc_server_app",
	}
	DocServerCallbackTable.Annotation = &entsql.Annotation{
		Table: "doc_server_callback",
	}
	DocServerGetProjectTable.Annotation = &entsql.Annotation{
		Table: "doc_server_get_project",
	}
	DocServerProjectTable.Annotation = &entsql.Annotation{
		Table: "doc_server_project",
	}
}
